stages:
  - compile
  - build

compile-app:
  # Use the official maven image
  image: maven:3-jdk-11
  stage: compile
  # Package the app without test.
  script: "mvn package -Dmaven.test.skip"

build-app:
  # Use the official docker image
  image: docker:latest
  stage: build
  variables:
    IMAGE_NAME: $CI_REGISTRY_IMAGE/app
  services:
    - docker:dind
  before_script:
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
  # Default branch leaves tag empty (= latest tag)
  # All other branches are tagged with the escaped branch name (commit ref slug)
  script:
    - |
      if [[ "$CI_COMMIT_BRANCH" == "$CI_DEFAULT_BRANCH" ]]; then
        tag=""
        echo "Running on default branch '$CI_DEFAULT_BRANCH': tag = 'latest'"
      else
        tag=":$CI_COMMIT_REF_SLUG"
        echo "Running on branch '$CI_COMMIT_BRANCH': tag = $tag"
      fi
    - docker build -t "$IMAGE_NAME${tag}" -f Dockerfile .
    - docker push "$IMAGE_NAME${tag}"
  # Run this job in a branch where a Dockerfile exists
  rules:
    - if: $CI_COMMIT_BRANCH
      exists:
        - Dockerfile
